package com.myco.jmstest;

import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.Properties;

import org.apache.log4j.PropertyConfigurator;
import org.hornetq.core.logging.Logger;
import org.hornetq.integration.logging.Log4jLogDelegateFactory;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class ListenerMain {

    public static void main(String[] args) throws InterruptedException {

        org.apache.log4j.Logger LOGGER = null;
        
        try {
            // get the default test log4j properties
            Properties log4jProperties = new Properties();
            log4jProperties.load(new FileReader(new File("cfg/log4j.properties")));
            PropertyConfigurator.configure(log4jProperties);
            
            LOGGER = org.apache.log4j.Logger.getLogger(ListenerMain.class);
        } catch (IOException e) {
            // Just ignore it
            e.printStackTrace();
        }

        // open/read the application context file
        final ClassPathXmlApplicationContext context = new ClassPathXmlApplicationContext(
                "file:cfg/listenerContext.xml");

        Logger.setDelegateFactory(new Log4jLogDelegateFactory());
        
        JmsListener listener = context.getBean(JmsListener.class);
        
        boolean receivedAllMessages = false;
        for(int i = 0; i < 100; i++) {
            if(listener.getNumberOfReceivedMsgs() != 10000000) {
                Thread.sleep(1000);
            } else {
                receivedAllMessages = true;
                break;
            }
        }
        
        if(receivedAllMessages) {
            LOGGER.info("Received all messages");
        } else {
            LOGGER.info("Did not receive all messages");
        }
        
        // Shutdown
        context.close();
    }

}
